Codeforces Round #308 (Div. 2) E. Vanya and Brackets

2024-05-14 11:58

本文主要是介绍Codeforces Round #308 (Div. 2) E. Vanya and Brackets,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

E. Vanya and Brackets
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Vanya is doing his maths homework. He has an expression of form , where x1, x2, ..., xn are digits from 1 to 9, and sign  represents either a plus '+' or the multiplication sign '*'. Vanya needs to add one pair of brackets in this expression so that to maximize the value of the resulting expression.

Input

The first line contains expression s (1 ≤ |s| ≤ 5001|s| is odd), its odd positions only contain digits from 1 to 9, and even positions only contain signs  +  and  * .

The number of signs  *  doesn't exceed 15.

Output

In the first line print the maximum possible value of an expression.

Sample test(s)
input
3+5*7+8*4
output
303
input
2+3*5
output
25
input
3*4*5
output
60
Note

Note to the first sample test. 3 + 5 * (7 + 8) * 4 = 303.

Note to the second sample test. (2 + 3) * 5 = 25.

Note to the third sample test. (3 * 4) * 5 = 60 (also many other variants are valid, for instance, (3) * 4 * 5 = 60).

题目要求对一个只有加号乘号的数式加一对括号,要求和最大是多少,*的个数不超过15个,这个问题如果枚举至少也o(n^3),所以复杂度太高,考虑到

*号的个数很少,就可以想到(一定在*号的右边或开始,)一定在*的左边或开始,因为,如果存在这样的式子+(...)+,这括号加的没有意义,不能使等式

变大,如果存在*(....)+这样的式子,我们把)向右移可使式子变大,如果存在+(...)*,我们可以把(向左移使得式子变大,这样,枚举一下,总的复杂度为n*17*17个,足够了!

#define INF			9000000000000000000
#define EPS			(double)1e-9
#define mod			1000000007
#define PI			3.14159265358979
//*******************************************************************************/
#endif
#define N 5005
#define MOD 1000000007
int n,len,leftt[30],leftnum,rightt[30],rightnum;
long long ans;
char str[N],temp[N];
stack<char> opS;
stack<long long> numS;
int getNum(char c){if(c == '(')return 3;else if(c == '*')return 2;else if(c == '+')return 1;else if(c == ')')return 0;return -1;
}
bool isdigit(char c){if(c>='0' && c<='9')return true;return false;
}
bool PopCal(){char op = opS.top();opS.pop();//cout<<op<<endl;if(op == '+'){long long num1 = numS.top();numS.pop();long long num2 = numS.top();numS.pop();numS.push(num1 + num2);}else if(op == '*'){long long num1 = numS.top();numS.pop();long long num2 = numS.top();numS.pop();numS.push(num1 * num2);}elsereturn true;return false;
}
long long cal(char s[],int l){while(!opS.empty()) opS.pop();while(!numS.empty()) numS.pop();for(int i=0;i<l;i++){if(isdigit(s[i]))numS.push(s[i]-'0');else {while(!opS.empty() && getNum(s[i]) <= getNum(opS.top())){if(opS.top() == '(' && s[i]!=')')break;if(PopCal())break;}if(s[i] != ')')opS.push(s[i]);}}while(!opS.empty()){PopCal();}return numS.top();
}
int main()
{//cout<<cal("3+5*(7+8)*4",11);while (SS(str) != EOF){len = strlen(str);leftnum = 0;rightnum = 0;leftt[leftnum++] = -1;ans = 0;FI(len){if(str[i] == '*'){leftt[leftnum++] = i;rightt[rightnum++] = i;}}rightt[rightnum++] = len;FI(leftnum)FJ(rightnum){if(rightt[j] > leftt[i]){int count = 0;if(leftt[i] == -1) temp[count++] = '(';for(int k=0;k<len;k++){if(k == leftt[i]){temp[count++] = str[k];temp[count++] = '(';}else if(k == rightt[j]){temp[count++] = ')';temp[count++] = str[k];}else {temp[count++] = str[k];}}if(rightt[j] == len) temp[count++] = ')';temp[count] = '\0';//printf("%d %d %d %d %s ",i,j,leftt[i],rightt[j],temp);ans = max(ans,cal(temp,len+2));//cout<<cal(temp,len+2)<<endl;}}cout<<ans<<endl;}return 0;
}


这篇关于Codeforces Round #308 (Div. 2) E. Vanya and Brackets的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/988687

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

CSS实现DIV三角形

本文内容收集来自网络 #triangle-up {width: 0;height: 0;border-left: 50px solid transparent;border-right: 50px solid transparent;border-bottom: 100px solid red;} #triangle-down {width: 0;height: 0;bor

创建一个大的DIV,里面的包含两个DIV是可以自由移动

创建一个大的DIV,里面的包含两个DIV是可以自由移动 <body>         <div style="position: relative; background:#DDF8CF;line-height: 50px"> <div style="text-align: center; width: 100%;padding-top: 0px;"><h3>定&nbsp;位&nbsp;

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

【UVA】1626-Brackets sequence(动态规划)

一道算是比较难理解的动规。 状态转移分2个: (用d[i][j]表示在i~j内最少需要添加几个括号,保持平衡) 1.如果s[i]和s[j]是一对括号,那么d[i][j] = d[i + 1][j - 1] 2.否则的话 d[i][j] = min(d[i][k],[k + 1][j]); 边界是d[i + 1][i] = 0; d[i][i] = 1; 13993644 162

CF#271 (Div. 2) D.(dp)

D. Flowers time limit per test 1.5 seconds memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/474/problem/D We s